package elena.work;

public class TestReaderWriter {

	public static void main(String[] args) {
		ReaderWriter rw = new ReaderWriter();
		Reader r1 = new Reader(rw, 20);
		r1.setName("Reader1");
		r1.start();
		Reader r2 = new Reader(rw, 30);
		r2.setName("Reader2");
		r2.start();
		Reader r3 = new Reader(rw, 25);
		r3.setName("Reader3");
		r3.start();
		Writer w1 = new Writer(rw, 25);
		w1.setName("Writer1");
		w1.start();
		Writer w2 = new Writer(rw, 30);
		w2.setName("Writer2");
		w2.start();
	}
}

class Reader extends Thread {
	ReaderWriter rw;
	int delay;
	
	Reader(ReaderWriter rw, int time) {
		this.rw = rw;
		delay = time;
	}
	
	public void run() {
		try {
			for(int i=0; i<4; i++) {
				System.out.println(this.getName() + "-n." + i + " - shared()");
				rw.shared();
				sleep(25);
				System.out.println(this.getName() + "-n." + i + " - releaseShared()");
				rw.releaseShared();
				sleep(delay);
			}
		} catch (InterruptedException e) {
			return;
		}
	}
}

class Writer extends Thread {
	ReaderWriter rw;
	int delay;
	
	Writer(ReaderWriter rw, int time) {
		this.rw = rw;
		delay = time;
	}
	
	public void run() {
		try {
			for(int i=0; i<4; i++) {
				System.out.println(this.getName() + "-n." + i + " - exclusive()");
				rw.exclusive();
				sleep(25);
				System.out.println(this.getName() + "-n." + i + " - releaseExclusive()");
				rw.releaseExclusive();
				sleep(delay);
			}
		} catch (InterruptedException e) {
			return;
		}
	}
}
