package elena.work;

public class TestReaderWriterFair {

	public static void main(String[] args) {
		ReaderWriterFair rw = new ReaderWriterFair();
		ReaderFair r1 = new ReaderFair(rw, 20);
		r1.setName("Reader1");
		r1.start();
		ReaderFair r2 = new ReaderFair(rw, 30);
		r2.setName("Reader2");
		r2.start();
		ReaderFair r3 = new ReaderFair(rw, 25);
		r3.setName("Reader3");
		r3.start();
		WriterFair w1 = new WriterFair(rw, 25);
		w1.setName("Writer1");
		w1.start();
		WriterFair w2 = new WriterFair(rw, 30);
		w2.setName("Writer2");
		w2.start();
	}
}

class ReaderFair extends Thread {
	ReaderWriterFair rw;
	int delay;

	ReaderFair(ReaderWriterFair rw, int time) {
		this.rw = rw;
		delay = time;
	}

	public void run() {
		try {
			for(int i=0; i<4; i++) {
				System.out.println(this.getName() + "-n." + i + " - shared()");
				rw.shared();
				sleep(25);
				System.out.println(this.getName() + "-n." + i + " - releaseShared()");
				rw.releaseShared();
				sleep(delay);
			}
		} catch (InterruptedException e) {
			return;
		}
	}
}

class WriterFair extends Thread {
	ReaderWriterFair rw;
	int delay;

	WriterFair(ReaderWriterFair rw, int time) {
		this.rw = rw;
		delay = time;
	}

	public void run() {
		try {
			for(int i=0; i<4; i++) {
				System.out.println(this.getName() + "-n." + i + " - exclusive()");
				rw.exclusive();
				sleep(25);
				System.out.println(this.getName() + "-n." + i + " - releaseExclusive()");
				rw.releaseExclusive();
				sleep(delay);
			}
		} catch (InterruptedException e) {
			return;
		}
	}
}
